#version 300 es

precision highp float;

uniform sampler2D u_Texture;
uniform vec4 u_dotColor;
uniform vec4 u_lineColor;
uniform vec4 u_gridControl;

in vec3 v_TexCoordAlpha;

out vec4 fragColor;

void main() {
  vec4 control = texture(u_Texture, v_TexCoordAlpha.xy);
  float dotScale = v_TexCoordAlpha.z;
  float lineFade = max(0.0, u_gridControl.z * v_TexCoordAlpha.z - (u_gridControl.z - 1.0));
  vec3 color = (control.r * dotScale > u_gridControl.x) ? u_dotColor.rgb
             : (control.g > u_gridControl.y)            ? u_lineColor.rgb * lineFade
                                                        : (u_lineColor.rgb * 0.25 * lineFade) ;
  fragColor = vec4(color, v_TexCoordAlpha.z * u_gridControl.w);
}
